!DIR$ FIXEDFORMLINESIZE:132
      subroutine dd_u_CYL(mode, errcode)
      use rte_blocks
      implicit none

      integer*4, intent(in)  :: mode
      integer*4, intent(out) :: errcode

      integer*8   irec, n, n_max

      real*4      fun
      real*4      rho, z, rho_of_irho, z_of_iz

      integer*4   k, l, irho, iz

      integer*4 ind

      real(nword), allocatable, dimension(:)     :: v
      real(nword), allocatable, dimension(:,:) :: u

      errcode = 0

      n_max   = int8(lrho)*int8(lz)

      allocate(v(1:nline))
      allocate(u(1:lrho,1:lz))

      irec = 2
      read(80,rec=irec,err=1002) (v(l), l=1,nline)

      k = 0
      n = 0
      do 1, iz=1,lz
      do 1, irho=1,lrho
      k=k+1
      n=n+1
      u(irho,iz) = v(k)
      if(k .eq. nline) then
         if(n .lt. n_max) then
            irec = irec+1 
            read(80,rec=irec,err=1002) (v(l), l=1,nline)
            k = 0
         else
            continue
         end if
      end if
 1    continue

      close(unit=80,err=1003)
      write(*,*) irec, 'records successfully read'

      deallocate(v)

 100  continue

      write(*,*) '***** u(r) = u(rho, z). Make a choice: *********************'
      write(*,*) '   Display u(rho     , z   ) as a function of (rho,z)    [1]'
      write(*,*) '   Display u(rho     , z=z0) as a function of rho        [2]'
      write(*,*) '   Display u(rho=rho0, z   ) as a function of z          [3]'
      write(*,*) '************************************************************'

      read(*,*) ind
      if((ind .lt. 1) .or. (ind .gt. 3)) then
         write(*,*) 'Response is outside of range or incorrect. Try again'
         goto 100
      end if
c
c------------- Getting integer idexes -------------------------
c
      if      (mode .eq. 1) then
         call gip_u_CYL(ind, irho, iz)
      else if (mode .eq. 2) then
         call gii_u_CYL(ind, irho, iz)
      else
         errcode = 1
         return
      end if

c
c------------- Writing data out --------------------------------------
c

      IF     (ind .eq. 1) THEN

         open(unit=70, file='u_rho_z',status='unknown')

         do 11, iz=1,Lz
         z = z_of_iz(iz)
         do 11, irho=1,Lrho
         rho = rho_of_irho(irho)
         fun = u(irho,iz)
         write(70,*) rho, z, fun
 11      continue

         write(*,*) '.... Output written to file "u_rho_z" '
         write(*,*) '................... Format: rho, z, u '

      ELSE IF(ind .eq. 2) THEN

         open(unit=70, file='u_rho',status='unknown')

         do 12, irho=1,Lrho
         rho = rho_of_irho(irho)
         fun = u(irho,iz)
         write(70,*) rho, fun
 12      continue

         write(*,*) '....... Output written to file "u_rho" '
         write(*,*) '....................... Format: rho, u '

      ELSE IF(ind .eq. 3) THEN

         open(unit=70, file='u_z',status='unknown')

         do 13, iz=1,Lz
         z = z_of_iz(iz)
         fun = u(irho,iz)
         write(70,*) z, fun
 13      continue

         write(*,*) '....... Output written to file "u_z" '
         write(*,*) '...................... Format:  z, u '

      ELSE

         write(*,*) 'Incorrect index (should be 1<=ind<=7); please try again'
         goto 100

      END IF

      close(unit=70)


      write(*,*) 'Make another choice to display more data'
      write(*,*) '============================================================'
      write(*,*) '============================================================'

      goto 100

      return

 1002 continue
      write(*,*) 'dd_u_CYL: Error reading binary data'
      errcode = 1002
      return

 1003 continue
      write(*,*) 'dd_u_CYL: Error closing input file'
      errcode = 1003
      return

      end
