      subroutine discard_rnums()
      use math_blocks
      use rte_blocks
      implicit none

      real*4,    dimension(1:nr) :: butch1, butch2, butch3
      integer*4, dimension(1:nr) :: butch4

c
c-------- RNs for all phase functions 
c
c-------- (STR1) Step length DEL: Exponential in [0,Inf], P[x]=Exp[-x]
      vsl_errcode = vsrngexponential(meth1,str1,nr,butch1,rzero,ru)
      call check_vsl_error(vsl_errcode)
c-------- (STR3) Azimuthal angle PHI: Uniform in [0,2*PI]      
      vsl_errcode = vsrnguniform(meth3,str3,nr,butch3,rzero,pi2)
      call check_vsl_error(vsl_errcode)
c-------- (STR4) Absorption probability: Binary
      vsl_errcode = virngbernoulli(meth4,str4,nr,butch4,albedo)
      call check_vsl_error(vsl_errcode)


c-------- (STR2) Cosine of polar angle CTH
c     Specific to each phase function

c-------- a) PP=HG 

      IF(PhaseFunction .eq. 'HG') THEN

      vsl_errcode = vsrnguniform(meth2,str2,nr,butch2,rzero,ru)
      call check_vsl_error(vsl_errcode)

c-------- b) PP=HG0 (0<|g|<0.01)

      ELSE IF(PhaseFunction .eq. 'HG0') THEN

      vsl_errcode = vsrnguniform(meth2,str2,nr,butch2,rzero,ru)
      call check_vsl_error(vsl_errcode)

c-------- c) PP=ISOTROPIC

      ELSE IF(PhaseFunction .eq. 'ISO') THEN

      vsl_errcode = vsrnguniform(meth2,str2,nr,butch2,-ru,ru)
      call check_vsl_error(vsl_errcode)

      ELSE IF(PhaseFunction .eq. 'EXP') THEN

      vsl_errcode = vsrnguniform(meth2,str2,nr,butch2,rzero,ru)
      call check_vsl_error(vsl_errcode)

      ELSE IF(PhaseFunction .eq. 'RAY') THEN

         write(*,*) 'Oops..'
         pause

      ELSE IF(PhaseFunction .eq. 'DEL') THEN

         write(*,*) 'Oops..'
         pause

      ELSE

         write(*,*) 'Incorrect PP'
         pause

      END IF

      return
      end

