!DIR$ FIXEDFORMLINESIZE:132
      subroutine dump_J_2D(name, J, fail)
      use rte_blocks
      use header_types
      implicit none

      character*32, intent(in)  :: name
      real(nword) , intent(in)  :: J(1:N0,1:L1)
      logical*4   , intent(out) :: fail

      integer*4 i1
      real*4    rho, rho_of_irho
      
      integer*4 my_name_length
      parameter(my_name_length=12)
      character(my_name_length) my_name
      parameter(my_name='   dump_J_2D')

      fail = .false.

      open(unit=80, file=name, status='unknown', err=100)

 401  format(a3, a32)
 402  format(a27, a8, a41)

      write(80,401,err=101) '#  ',  string%Filetype
      write(80,402,err=101) '#   Format: rho, [units of ', Units, '], Jrho/mu_t^2, Jz/mu_t^2 [dimensionless]'
      do 1, i1=1,L1
      rho = rho_of_irho(i1)
      write(80,*,err=101) rho/scale, sngl(J(1,i1)), sngl(J(2,i1))
 1    continue
      close(unit=80,err=102)

 400  format(a<my_name_length>, a1, i10, a37, a32)
      write(*,400) my_name, ':', L1, ' lines successfully written to file: ', name

      return

 100  continue
      write(*,*) my_name, ': Error openning direct-access file'
      fail = .true.
      return

 101  continue
      write(*,*) my_name, ': Error writing direct-access file'
      fail = .true.
      return

 102  continue
      write(*,*) my_name, ': Error writing direct-access file'
      fail = .true.
      return

      end
