!DIR$ FIXEDFORMLINESIZE:132
      subroutine dump_J_4D(name, J, fail)
      use rte_blocks
      use header_types
      implicit none

      character*32, intent(in)  :: name
      real(nword) , intent(in)  :: J(1:N0,1:L1,1:L2,1:L3)
      logical*4   , intent(out) :: fail

      integer*8 irec
      integer*4 i0, i1, i2, i3, k, l
      
      integer*4 my_name_length
      parameter(my_name_length=12)
      character(my_name_length) my_name
      parameter(my_name='   dump_J_4D')

      real(nword), allocatable, dimension(:) :: v

      fail = .false.

      allocate(v(1:nline))

      open(unit=80, file=name, status='unknown', access='direct', recl=len, err=100)

      irec = 1
      write(80,rec=irec,err=101) string

      k = 0
      do 1, i3=1,L3
      do 1, i2=1,L2
      do 1, i1=1,L1
      do 1, i0=1,N0
      k=k+1
      v(k) = J(i0,i1,i2,i3)
      if(k .eq. nline) then
         irec = irec+1 
         write(80,rec=irec,err=101) (v(l), l=1,nline)
         k = 0
      end if
 1    continue
      if(k .gt. 0) then
         irec = irec+1 
         write(80,rec=irec,err=101) (v(l), l=1,k)
      end if

      close(unit=80,err=102)

 400  format(a<my_name_length>, a1, i10, a39, a32)
      write(*,400) my_name, ':', irec, ' records successfully written to file: ', name

      deallocate(v)

      return

 100  continue
      write(*,*) my_name, ': Error openning direct-access file'
      fail = .true.
      return

 101  continue
      write(*,*) my_name, ': Error writing direct-access file'
      fail = .true.
      return

 102  continue
      write(*,*) my_name, ': Error closing direct-access file'
      fail = .true.
      return

      end
