!DIR$ FIXEDFORMLINESIZE:132
      subroutine dump_gen_1D(name, arr, call_point, fail)
      use rte_blocks
      use header_types
      implicit none

      character*32, intent(in)  :: name
      character*32, intent(in)  :: call_point
      real(nword) , intent(in)  :: arr(1:L1)
      logical*4   , intent(out) :: fail

      integer*4 i1
      real*4    rho, rho_of_irho, z, z_of_iz
      
      integer*4 my_name_length
      parameter(my_name_length=12)
      character(my_name_length) my_name
      parameter(my_name=' dump_gen_1D')

 401  format(a3, a32)
 402  format(a27, a8, a27)

      fail = .false.

      open(unit=80, file=name, status='unknown', err=100)

      write(80,401,err=101) '#  ',  string%Filetype

      IF(call_point .eq. '**** wd_pnts_sur_cyl: u1D ******') THEN

      write(80,402,err=101) '#   Format: rho, [units of ', Units, '], u/mu_t^2 [dimensionless]'
      do 1, i1=1,L1
      rho = rho_of_irho(i1)
      write(80,*,err=101) rho/scale, sngl(arr(i1))
 1    continue

      ELSE IF(call_point .eq. '**** wd_plws_vol_cyl: u1D ******') THEN

      write(80,402,err=101) '#   Format: z, [units of ', Units, '], u [dimensionless]'
      do 2, i1=1,L1
      z = z_of_iz(i1)
      write(80,*,err=101) z/scale, sngl(arr(i1))
 2    continue

      ELSE IF(call_point .eq. '**** wd_plws_vol_cyl: J1D ******') THEN

      write(80,402,err=101) '#   Format: z, [units of ', Units, '], Jz [dimensionless]'
      do 3, i1=1,L1
      z = z_of_iz(i1)
      write(80,*,err=101) z/scale, sngl(arr(i1))
 3    continue

      ELSE

         write(*,*) my_name, 'Unexpected Error (incorrect CALL_POINT); exiting'
         close(unit=80,err=102)
         return

      END IF

      close(unit=80,err=102)

 400  format(a<my_name_length>, a1, i10, a37, a32)
      write(*,400) my_name, ':', L1, ' lines successfully written to file: ', name

      return

 100  continue
      write(*,*) my_name, ': Error openning direct-access file'
      fail = .true.
      return

 101  continue
      write(*,*) my_name, ': Error writing direct-access file'
      fail = .true.
      return

 102  continue
      write(*,*) my_name, ': Error writing direct-access file'
      fail = .true.
      return

      end
